# SourcePath: perl/20201130dev
Summary: The Pathologically Eclectic Rubbish Lister
Name: sony-target-dev-perl
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-perl
Version: 5.22.0
Release: 12000003
URL: http://www.perl.org
Source0: perl-%{version}.tar.gz
Source1: perl-config-defaults.sh-5.22.0
Source2: config.sh-5.22.0
Source3: config.sh-32-5.22.0
Source4: config.sh-32-le-5.22.0
Source5: config.sh-32-be-5.22.0 
Source6: config.sh-64-5.22.0
Source7: config.sh-64-le-5.22.0
Source8: config.sh-64-be-5.22.0 
Patch0: perl-5.22.0-multidialect-support.patch
Patch1: perl-5.22.0-Makefile.patch
Patch2: perl-5.22.0-Makefile.SH.patch
Patch3: perl-5.22.0-installperl.patch
Patch4: perl-5.22.0-dynloader.patch
Patch5: perl-5.22.0-moreconfig.patch
Patch6: perl-5.22.0-letgcc-find-errno.patch
Patch7: perl-5.22.0-generate-sh.patch
Patch8: perl-5.22.0-native-perlinc.patch
Patch9: perl-5.22.0-enable-gdbm.patch
Patch10: perl-5.22.0-cross-generate_uudmap.patch
Patch11: perl-5.22.0-archlib-exp.patch
Patch12: perl-5.22.0-dynaloderhack.patch
Patch13: perl-5.22.0-Makefile.SH-fix-do-install-failed.patch
Patch14: perl-5.22.0-CVE-2016-2381.patch
Patch15: perl-5.22.0-CVE-2016-6185.patch
Patch16: perl-5.22.0-CVE-2015-8607.patch
Patch17: perl-5.22.0-CVE-2016-1238.patch
Patch18: perl-5.22.0-CVE-2015-8853.patch
Patch19: perl-5.22.0-CVE-2017-12837.patch
Patch20: perl-5.22.0-CVE-2017-12883.patch
Patch21: perl-5.22.0-CVE-2017-6512-pre.patch
Patch22: perl-5.22.0-CVE-2017-6512.patch
Patch23: perl-5.22.0-CVE-2018-6797.patch
Patch24: perl-5.22.0-CVE-2018-6798-1.patch
Patch25: perl-5.22.0-CVE-2018-6798-2.patch
Patch26: perl-5.22.0-CVE-2018-6798-3.patch
Patch27: perl-5.22.0-CVE-2018-6913.patch
Patch28: perl-5.22.0-CVE-2018-12015.patch
Patch29: perl-5.22.0-CVE-2018-18311.patch
Patch30: perl-5.22.0-CVE-2018-18312.patch
Patch31: perl-5.22.0-CVE-2018-18313.patch
Patch32: perl-5.22.0-CVE-2018-18314.patch
Patch33: perl-5.22.0-CVE-2020-10543.patch
Patch34: perl-5.22.0-CVE-2020-10878.patch
Patch35: perl-5.22.0-CVE-2020-12723.patch

License: Artistic License and/or GPL1
Group: %{sony_group}
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Buildroot: %{_tmppath}/%{name}-root
# The buildrequires is because we MUST have longdbl support in platformtest
BuildRequires: %{sony_tool_triplet}-cross-platformtest
BuildRequires: %{sony_tool_triplet}-%{sony_target_dialect}-dev-gdbm
Prefix: %{sony_target_dir}
Provides: /usr/bin/perl

%description
A scripting language with delusions of full language-hood, Perl is used
in many system scripts and utilities.

Perl is optimised for scanning arbitrary text files and system
administration.  It has built-in extended regular expression matching
and replacement, a data-flow mechanism to improve security with
setuid scripts and is extensible via modules that can interface to C
libraries. However, it is particularly prone to unreadable syntax.

%package -n %{pkgname}
Summary: The Pathologically Eclectic Rubbish Lister
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
A scripting language with delusions of full language-hood, Perl is used
in many system scripts and utilities.

Perl is optimised for scanning arbitrary text files and system
administration.  It has built-in extended regular expression matching
and replacement, a data-flow mechanism to improve security with
setuid scripts and is extensible via modules that can interface to C
libraries. However, it is particularly prone to unreadable syntax.


%prep
%setup -q -n perl-%{version}

%patch0 -p1  
%patch1 -p1 
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1

ln -s NetWare/nwutil.h nwutil.h

%build
%sony_target_dev_setup
%target_acplatvars

export PERL5LIB=$PERL5LIB:%{sony_host_lib_dir}/perl/5.22.0
export PERLHOSTLIB="%{sony_host_lib_dir}/perl/5.22.0/"

ln -sf %{sony_host_bin_dir}/perl hostperl

cd Cross
rm -f config.sh-%{sony_tool_triplet}

for i in %{SOURCE2} %{SOURCE3} %{SOURCE4}; do
cat $i >> config.sh-%{sony_tool_triplet}
done

# Update some paths in the configuration
sed -i -e 's,@ARCH@-thread-multi,,g' \
       -e 's,@ARCH@,arm-sony-linux-gnueabi,g' \
       -e 's,@STAGINGDIR@,%{sony_target_dev_dir},g' \
       -e "s,@INCLUDEDIR@,%{sony_target_dev_include_dir},g" \
       -e "s,@LIBDIR@,%{sony_target_dev_lib_dir},g" \
       -e "s,@BASELIBDIR@,%{sony_target_dev_lib_dir},g" \
       -e "s,@EXECPREFIX@,%{sony_target_dev_exec_prefix},g" \
       -e 's,@USRBIN@,%{sony_target_dev_bin_dir},g' \
    config.sh-%{sony_tool_triplet}



case "%{sony_target_cpu}" in
    x86_64 | powerpc | s390)
    sed -i -e "s,\(need_va_copy=\)'undef',\1'define',g" \
    config.sh-%{sony_tool_triplet}
    ;;
    arm)
    sed -i -e "s,\(d_u32align=\)'undef',\1'define',g" \
    config.sh-%{sony_tool_triplet}
    ;;
esac


# mf you add to these subs watch that you are redirecting to the right files...
# Do HHL Substitutions
sed -e "s/%%{_hhl_target_name}/%{sony_target_name}/g" < %{SOURCE1} > config-defaults.sh.tmp
sed -e "s/%%{_hhl_target_config}/%{sony_tool_triplet}/g" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/%%{_hhl_target_cpu}/%{sony_target_cpu}/g" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/%%{_hhl_target_toolprefix}/%{sony_target_toolprefix}/g" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s@%%{buildroot}@%{buildroot}@g" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s@%%{_hhl_cross_target_dir}@%{sony_target_dir}@g" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s@%%{_hhl_target_dev_prefix}@%{sony_target_dev_prefix}@g" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s@%%{_hhl_target_prefix}@%{sony_target_dev_prefix}@g" < config-defaults.sh.tmp > config-defaults.sh

# Do Arch Specific subs..
sed -e "s/doublesize='HHLDEFINE'/doublesize='${ac_cv_sizeof_double}'/" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/longdblsize='HHLDEFINE'/longdblsize='${ac_cv_sizeof_long_double}'/" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/longlongsize='HHLDEFINE'/longlongsize='${ac_cv_sizeof_long_long}'/" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/longsize='HHLDEFINE'/longsize='${ac_cv_sizeof_long}'/" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/lseeksize='HHLDEFINE'/lseeksize='${ac_cv_sizeof_off_t}'/" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/ptrsize='HHLDEFINE'/ptrsize='${ac_cv_sizeof_void_p}'/" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/shortsize='HHLDEFINE'/shortsize='${ac_cv_sizeof_short}'/" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/intsize='HHLDEFINE'/intsize='${ac_cv_sizeof_int}'/" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/fpossize='HHLDEFINE'/fpossize='${ac_cv_sizeof_fpos_t}'/" < config-defaults.sh > config-defaults.sh.tmp
sed -e "s/charsize='HHLDEFINE'/charsize='${ac_cv_sizeof_char}'/" < config-defaults.sh.tmp > config-defaults.sh
sed -e "s/nvsize='HHLDEFINE'/nvsize='${ac_cv_sizeof_double}'/" < config-defaults.sh > config-defaults.sh.tmp
cat config-defaults.sh.tmp > config-defaults.sh

# This is really annoying, all this does is work around some possible 
# issues use -f option to Configure
cp config-defaults.sh config.sh

# Add in the *symbols defines...
bash %{SOURCE3} >> config.sh


%if "%{sony_target_dialect}" == "armv7a"
mv config.sh config.sh.tmp
sed -e "s@%{sony_target_toolprefix}gcc@%{sony_target_toolprefix}gcc -tarmv7a @g" < config.sh.tmp > config.sh
%endif

%if "%{sony_target_dialect}" == "thumb2"
mv config.sh config.sh.tmp
sed -e "s@%{sony_target_toolprefix}gcc@%{sony_target_toolprefix}gcc -tthumb2 @g" < config.sh.tmp > config.sh
%endif


rm -rf config
echo "ARCH = arm" > config
echo "OS = sony-linux-gnueabi" >> config

make perl CC="${CC}" LD="${CC} -shared" -k | tee -a build.log

%install
rm -rf %{buildroot}
%sony_target_dev_setup
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_prefix}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_exec_prefix}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_info_dir}

export PERLHOSTLIB="%{sony_host_lib_dir}/perl/5.22.0/"
make install DESTDIR=%{buildroot}%{sony_target_dir}

# Remove cruft
rm -f %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/perl/%{version}/.packlist
rm -f %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/perl/%{version}/CORE/sperl.o
rm -f %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/perl/%{version}/unicode/mktables.PL

# Remove non-applicable help files
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_info_dir}/
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/perl/site_perl/

mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/perl/%{version}/CORE/libperl.so %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libperl.so.5.22.0

for i in  `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libperl.so.5.22.0`; do
	ln -s libperl.so.5.22.0 %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libperl.so.5
        ln -sf ../../../libperl.so.5.22.0 %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/perl/%{version}/CORE/libperl.so
done

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
 %defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_bin_dir}/*
%{sony_target_dir}%{sony_target_dev_lib_dir}/*


%changelog
* Mon Nov 30 2020 Sony Corporation
- Fixed CVE-2020-10543, CVE-2020-10878 and CVE-2020-12723

* Tue Nov 26 2019 Sony Corporation
- Fixed CVE-2017-12883 CVE-2017-12837 CVE-2017-6512
  CVE-2018-6913 CVE-2018-6798 CVE-2018-6797 CVE-2018-12015
  CVE-2018-18314 CVE-2018-18312 CVE-2018-18311 CVE-2018-18313

* Wed Jan 25 2017 Sony Corporation
- Version up to perl-5.22.0
- fixed CVE-2016-2381 -CVE-2016-6185 CVE-2015-8607
  CVE-2016-1238 CVE-2015-8853

* Fri Apr 12 2013 Sony Corporation
- perl 5.14.2 initial version
